library CreateProcessHook;

{$IMAGEBASE $42800000}

uses
  Windows,
  madCodeHook,
  sysutils;

// ***************************************************************

var
  CreateProcessNext             : function (lpApplicationName: PChar; lpCommandLine: PChar;
       lpProcessAttributes, lpThreadAttributes: PSecurityAttributes;
       bInheritHandles: BOOL; dwCreationFlags: DWORD; lpEnvironment: Pointer;
       lpCurrentDirectory: PChar; const lpStartupInfo: TStartupInfo;
       var lpProcessInformation: TProcessInformation) : bool; stdcall;

procedure log(s:string);
var f:textfile;
begin
  assignfile(f,'c:\hooking.log');
  try
    append(f);
  except
    rewrite(f);
  end;
  writeln(f,s);
  closefile(f);
end;

function IsCreateProcessAllowed(lpApplicationName, lpCommandLine: pchar ) : boolean;
var b1 : boolean;
begin
  log('IsCreateProcessAllowed for:');
  log('process: '+lpApplicationName);
  log('cmd line: '+lpCommandLine);
  try
    b1 := false;
    if not SendIpcMessage('CreateProcessIpcQueue', pchar(lpApplicationName+#13#10+lpCommandLine), 4, @b1, 1, 5000, false) then
    begin
      log('!! sendipcmessage returned false');
      SetLastError(ERROR_ACCESS_DENIED);
    end;
    result := b1;
  except
    on e:exception do
    begin
      log('error in dll: '+e.message);
      result:=true;
    end;
  end;
  log('returning: '+booltostr(result,true));
end;

function CreateProcessCallback(lpApplicationName: PChar; lpCommandLine: PChar;
  lpProcessAttributes, lpThreadAttributes: PSecurityAttributes;
  bInheritHandles: BOOL; dwCreationFlags: DWORD; lpEnvironment: Pointer;
  lpCurrentDirectory: PChar; const lpStartupInfo: TStartupInfo;
  var lpProcessInformation: TProcessInformation) : bool; stdcall;
begin
  log('CreateProcessCallback');
  result := IsCreateProcessAllowed(lpApplicationName,lpCommandLine) and
            CreateProcessNext(lpApplicationName,lpCommandLine,
      lpProcessAttributes, lpThreadAttributes,
      bInheritHandles,dwCreationFlags,lpEnvironment,
      lpCurrentDirectory,lpStartupInfo,
      lpProcessInformation);
end;

// ***************************************************************

begin
  log('hoooking....');
  log('hook ok? '+booltostr(HookAPI( kernel32, 'CreateProcessA', @CreateProcessCallback, @CreateProcessNext), true));
end.
